// plug_2.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"
#include "plugin_utils.h"
int kilid;
BZ_GET_PLUGIN_VERSION

class plug_2Handler : public bz_EventHandler
  {
  public:
    
    virtual void process(bz_EventData *eventData);
    
    // Add additional plug-in data here.
    
  };

plug_2Handler plug_2;

BZF_PLUGIN_CALL int bz_Load(const char* /*commandLine*/)
{
  // Add any initialization stuff here.
  
  bz_registerEvent(bz_ePlayerDieEvent, &plug_2);
  bz_registerEvent(bz_eFlagTransferredEvent, &plug_2);
  
  bz_debugMessage(4,"THKilles plugin loaded");
  return 0;
}

void plug_2Handler::process(bz_EventData *eventData)
{
  switch (eventData->eventType)
  {
    case bz_ePlayerDieEvent: //A player dies
    {
      bz_PlayerDieEventData* diedata = (bz_PlayerDieEventData*)eventData;
	 
      // Members for bz_PlayerDieEventData:
	 
      // int playerID: The victim's ID
      // bz_eTeamType team: The victim's team
      // int killerID: The killer's ID
      // bz_eTeamType killerTeam: The killer's team
      // bzApiString flagKilledWith: The flag that the killer shot the victim with
      // int shotID: The shot ID of the bullet that killed the victim
      // float pos[3]: The victim's position at the time of the kill
      // float rot: The direction of the victim
      // double time: The game time (in seconds)
	 if (diedata->flagKilledWith != "TH") break;
	 bz_fireWorldWep("SW", 50, BZ_SERVER, diedata->pos, 0, 0, 0, 0);
    }
	 break;
	 
    case bz_eFlagTransferredEvent: //A flag is transferred (with the thief flag)
    {
      bz_FlagTransferredEventData* flagtransferdata = (bz_FlagTransferredEventData*)eventData;
	 
      // Members for bz_FlagTransferredEventData:
	 
      // int fromPlayerID: The player the flag was sent from
      // int toPlayerID: The player the flag was sent to
      // char *flagType: The flag type
      // enum Action action: The action to take (ContinueSteal, CancelSteal, or DropThief)
	 bz_killPlayer(flagtransferdata->fromPlayerID, true, flagtransferdata->toPlayerID, "TH");
	 kilid = flagtransferdata->toPlayerID;
	 bz_sendTextMessage(BZ_SERVER, flagtransferdata->fromPlayerID, "Thief KILLS!");
	 }
	 break;
	 
  }
}


BZF_PLUGIN_CALL int bz_Unload()
{
  // Add any clean-up/shutdown stuff here.
  
  bz_removeEvent(bz_ePlayerDieEvent, &plug_2);
  bz_removeEvent(bz_eFlagTransferredEvent, &plug_2);
  
  bz_debugMessage(4,"THKilles plugin unloaded");
  return 0;
  
}

// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8